<?php
class validator {
	
	var  $lng_id_;	//Language ID.
	var $msg =array();
	var $field_list =array();
	var $POSTDAT =array();	
	var $err=array();
		
    function validator($POSTDAT, $lngid='jp') {
    	$this->lng_id_ =$lngid; 
    	$this->POSTDAT = $POSTDAT;
    	    	 
    	//Read errormessage from container.ini file.
    	$this->msg = parse_ini_file("validate/container.ini", true); 
    	//Load field list for check validity.
    	$this->field_list = $this->getFieldsList($this->msg );    	
    }
    
    
    //
     function form($flag){

    	if($flag){    		
    		if($this->field_list){
    			foreach ($this->field_list as $key => $val){
    				
    				switch($this->msg[$val]['validate']){
    					case 'email':
    						$_str_ =$this->email($val,$this->POSTDAT[$key]);
    						if($_str_){
    							$this->err[$key] = $_str_;
    						}
    					break;
    					case 'text':
    						$_str_ =$this->text($val,$this->POSTDAT[$key]);
    						if($_str_){
    							$this->err[$key] = $_str_;
    						}
    					break;
    					case 'text1':
    						$_str_ =$this->text1($this->POSTDAT[$key]);
    						if($_str_){
    							$this->err[$key] = $_str_;
    						}
    					break;
    					case 'name':
    						$_str_ =$this->name($val,$this->POSTDAT[$key]);
    						if($_str_){
    							$this->err[$key] = $_str_;
    						}
    					break;
    					case 'kkana':
    						$_str_ =$this->kkana($val,$this->POSTDAT[$key]);
    						if($_str_){
    							$this->err[$key] = $_str_;
    						}
    					break;
    					case 'eng':
    						$_str_ =$this->eng($val,$this->POSTDAT[$key]);
    						if($_str_){
    							$this->err[$key] = $_str_;
    						}
    					break;
    					
    				}
    			}
    		}
    	}else return true;
    }
    
    // Field list for check validity.
    function getFieldsList($allmsg){
    	$_list = array();    	
    	if (array_key_exists('validate',$allmsg)){
    		$_fields_vtype = split(',',$allmsg['validate']['list']);
    		
    		if ($_fields_vtype){    			
    			foreach($_fields_vtype as $key => $val){    				
    				$_l= split('#',$val);    				
    				if($_l){
    					$_list[$_l[0]]= $_l[1];
    				}
    			}
				
    		}
    	}
    	return $_list;    	
    	
    }
    
    //Text validator.
    function text($val,$str,$lngid=''){    	
 	
    	$tmp_lng_id_ =$lngid!='' ? $lngid:$this->lng_id_;

		if(array_key_exists('mxln',$this->msg[$val])){				
			if(mb_strlen($str, '8bit')>$this->msg[$val]['mxln'] && $this->msg[$val]['mxln']>0 ){			
				return $this->msg[$val][$tmp_lng_id_.'mx'];
			}
		}
		if(array_key_exists('minln',$this->msg[$val])){
			//echo $val;
			//echo $this->msg[$val]['mxln'];
			//print_r($this->msg);
			if(strlen($str)<$this->msg[$val]['minln'] && $this->msg[$val]['minln']>0 ){			
				return $this->msg[$val][$tmp_lng_id_.'min'];
			}
		}

		return null;    	
    }
    

    
    //special name validator.
    function name($val,$str,$lngid=''){    	
    	$tmp_lng_id_ =$lngid!='' ? $lngid:$this->lng_id_;    
		
    	if($str=="") 
		{			
			if(array_key_exists($tmp_lng_id_,$this->msg[$val])){
				return $this->msg[$val][$tmp_lng_id_];
			}else{
				return "Error message dose not set.";
			}
		}
		if(array_key_exists('mxln',$this->msg[$val])){
			if(strlen($str)>$this->msg[$val]['mxln'] && $this->msg[$val]['mxln']>0 ){			
				return $this->msg[$val][$tmp_lng_id_.'mx'];
			}
		}
		if(array_key_exists('minln',$this->msg[$val])){
			if(strlen($str)<$this->msg[$val]['minln'] && $this->msg[$val]['minln']>0 ){			
				return $this->msg[$val][$tmp_lng_id_.'min'];
			}
		}

		//To check is it contain any number?		
		$cmp = '%0123456789^!\"#%[$&\'()|*/+-?{\\';
		$INTERNAL_CODE ="EUC";
		for($i=0; $i<mb_strlen($str, $INTERNAL_CODE); $i++){		
		      if (!strpos($cmp, mb_substr($str, $i, 1, $INTERNAL_CODE)) === FALSE) {
					if(array_key_exists($tmp_lng_id_,$this->msg[$val])){
						return $this->msg[$val][$tmp_lng_id_];
					}else{
						return "Error message dose not set.";
					}
				}
		}
		
		//If the name is english then should be uppercase.
		if(!preg_match("/[^a-zA-Z]+$/ ",$str)){			
			if(!ctype_upper($str)){
				if(array_key_exists($tmp_lng_id_,$this->msg[$val])){
					return $this->msg[$val][$tmp_lng_id_];
				}else{
					return "Error message dose not set.";
				}
			}
		}

		return null;    	
    }
    
    //KataKana validator.
    function kkana($val,$str,$lngid=''){    	
    	$tmp_lng_id_ =$lngid!='' ? $lngid:$this->lng_id_;
    	if($str==""){
			if(array_key_exists($tmp_lng_id_,$this->msg[$val])){
				return $this->msg[$val][$tmp_lng_id_];
			}else{
				return "Error message dose not set.";
			}
    	}
    	
    	if(array_key_exists('mxln',$this->msg[$val])){
			if(strlen($str)>$this->msg[$val]['mxln'] && $this->msg[$val]['mxln']>0 ){			
				return $this->msg[$val][$tmp_lng_id_.'mx'];
			}
		}
		if(array_key_exists('minln',$this->msg[$val])){
			if(strlen($str)<$this->msg[$val]['minln'] && $this->msg[$val]['minln']>0 ){			
				return $this->msg[$val][$tmp_lng_id_.'min'];
			}
		}
			
		$cmp = 'ｱｲｳｴｵｶｷｸｹｺｻｼｽｾｿﾀﾁﾂﾃﾄﾅﾆﾇﾈﾉﾊﾋﾌﾍﾎﾏﾐﾑﾒﾓﾔﾕﾖﾗﾘﾙﾚﾛﾜｦﾝｧｨｩｪｫヵヶｬｭｮｯ､｡ｰ｢｣ﾞﾟアイウエオカキクケコサシスセソタチツテトナニヌネノハヒフヘホマミムメモヤユヨラリルレロワヲンヴガギグゲゴザジズゼゾダヂヅデドバビブベボパピプペポァィゥェォャュョッ、。ー「」 　';
		$INTERNAL_CODE ="EUC";
			for($i=0; $i<mb_strlen($str, $INTERNAL_CODE); $i++){
				if (strpos($cmp, mb_substr($str, $i, 1, $INTERNAL_CODE)) === FALSE) {
					if(array_key_exists($tmp_lng_id_,$this->msg[$val])){
						return $this->msg[$val][$tmp_lng_id_];
					}else{
						return "Error message dose not set.";
					}
				}
			}

			

		return null;    	
    }
    
    //HiraKana validator.
    function hkana($val,$str,$lngid=''){    	
    	$tmp_lng_id_ =$lngid!='' ? $lngid:$this->lng_id_;    
		
    	
		if(array_key_exists('mxln',$this->msg[$val])){
			if(strlen($str)>$this->msg[$val]['mxln'] && $this->msg[$val]['mxln']>0 ){			
				return $this->msg[$val][$tmp_lng_id_.'mx'];
			}
		}
		if(array_key_exists('minln',$this->msg[$val])){
			if(strlen($str)<$this->msg[$val]['minln'] && $this->msg[$val]['minln']>0 ){			
				return $this->msg[$val][$tmp_lng_id_.'min'];
			}
		}
		if(( ereg( "^[\x41-\x5A|\x61-\x7A|\x30-\x39]+$", $str) ))
		{			
			if(array_key_exists($tmp_lng_id_,$this->msg[$val])){
				return $this->msg[$val][$tmp_lng_id_];
			}else{
				return "Error message dose not set.";
			}
		}
		
		return null;    	
    }
    
    //Email validator.
    function email($val,$str,$lngid=''){    	
    	$tmp_lng_id_ =$lngid!='' ? $lngid:$this->lng_id_;
    	
			if(array_key_exists('mxln',$this->msg[$val])){
				if(strlen($str)>$this->msg[$val]['mxln'] && $this->msg[$val]['mxln']>0 ){			
					return $this->msg[$val][$tmp_lng_id_.'mx'];
				}
			}
			if(array_key_exists('minln',$this->msg[$val])){
				if(strlen($str)<$this->msg[$val]['minln'] && $this->msg[$val]['minln']>0 ){			
					return $this->msg[$val][$tmp_lng_id_.'min'];
				}
			}
			if(!eregi("^([a-z0-9\\_\\.\\-]+)@([a-z0-9\\_\\.\\-]+)\\.([a-z]{2,4})$",$str)){			
				if(array_key_exists($tmp_lng_id_,$this->msg[$val])){
					return $this->msg[$val][$tmp_lng_id_];
				}else{
					return "Error message dose not set.";
				}
			}
		
		return null;    	
    }
    
    //special name validator.
    function eng($val,$str,$lngid=''){    	
    	$tmp_lng_id_ =$lngid!='' ? $lngid:$this->lng_id_;    
		
    	if($str=="") 
		{			
			if(array_key_exists($tmp_lng_id_,$this->msg[$val])){
				return $this->msg[$val][$tmp_lng_id_];
			}else{
				return "Error message dose not set.";
			}
		}
		if(array_key_exists('mxln',$this->msg[$val])){
			if(strlen($str)>$this->msg[$val]['mxln'] && $this->msg[$val]['mxln']>0 ){			
				return $this->msg[$val][$tmp_lng_id_.'mx'];
			}
		}
		if(array_key_exists('minln',$this->msg[$val])){
			if(strlen($str)<$this->msg[$val]['minln'] && $this->msg[$val]['minln']>0 ){			
				return $this->msg[$val][$tmp_lng_id_.'min'];
			}
		}
				
		//The string should be english and 0-9 only.		
		if(!preg_match("/^[a-zA-Z0-9_]+$/",$str)){
				if(array_key_exists($tmp_lng_id_,$this->msg[$val])){
					return $this->msg[$val][$tmp_lng_id_];
				}else{
					return "Error message dose not set.";
				}
			}
		return null;    	
    } 
    
}
?>