<?php

class FileUP {
	
	/*************************************************************************/
	/**																		**/
	/**	Move files from servers Temp location to Project's Temp location.	**/
	/**																		**/
	/*************************************************************************/
	function SYS_TMP_TO_IMAGE_TMP($_F_P , $_O_F = ''){
	
		// $_F_P :: $_FILES['name']
		// $_O_F :: $_POST['name']
		
		if($_F_P['name']=='')return null;
		
		/*************************************************************************/
		/**	Uniq Id for image													**/
		/*************************************************************************/	
		$_SID = uniqid();
		
		
		$new_tmp_path = "../common/image-tmp/";
		
		if(!is_dir($new_tmp_path)){
			mkdir($new_tmp_path, 0777);
		}
		
		$path_info = pathinfo(basename( $_F_P['name'])); 
		
		$img_tmp_path = $new_tmp_path .  $_SID . date('Gis').'.'.$path_info['extension']; 
		$_FNB =  $_SID . date('Gis').'.'.$path_info['extension'];
		
		if(move_uploaded_file($_F_P['tmp_name'], $img_tmp_path)) {	    
		    
		    if($_O_F!=''&& file_exists($new_tmp_path.$_O_F)){
		    	unlink($new_tmp_path.$_O_F);
		    }
		    
		    return $_FNB;	    
		    
		}else return null;
		
	}
	
	
	/*************************************************************************/
	/**																		**/
	/**	Move files from Project's Temp to module location.					**/
	/**																		**/
	/*************************************************************************/
	function MOVE_TO_IMAGE($MOD,$_F_N){
		
		$old_path = "../common/image-tmp/";
		$new_path = "../common/" . $MOD . "-image/";
			
		//------Move files.-------//
	    if($_F_N!=''&& file_exists($old_path.$_F_N)){
		
	    	if(copy($old_path.$_F_N, $new_path.$_F_N)) {
	    		unlink($old_path.$_F_N);
	    	}
	    }	
	}
	
	
	/*************************************************************************/
	/**																		**/
	/**	Move files from Module Image to Project's tmp location.				**/
	/**																		**/
	/*************************************************************************/
	function MOVE_TO_IMAGE_TMP($MOD , $_F_N){
	

		
		$old_path = "../common/" . $MOD . "-image/";
		$new_path = "../common/image-tmp/";
		
		if(!is_dir($new_path)){
			mkdir($new_path, 0777);
		}
			
		if($_F_N!=''&& file_exists($old_path.$_F_N)){
		
	    	if(copy($old_path.$_F_N, $new_path.$_F_N)) {
	    		//unlink($old_path.$_F_N);
	    	}
	    }
	}   
	
	
	/*************************************************************************/
	/**																		**/
	/**	Delete Old File.													**/
	/**																		**/
	/*************************************************************************/
    function DELETE_OLD_IMAGE($MOD ,$OLD_F_N, $NEW_F_N){

    	
    	$file_path = "../common/" . $MOD . "-image/";
    	
    	foreach ($OLD_F_N as $key=>$val){
    		
    		if($OLD_F_N[$key] != $NEW_F_N[$key]){
	    		if($OLD_F_N[$key]!=''&& file_exists($file_path.$OLD_F_N[$key])){	
		    
		    		unlink($file_path.$OLD_F_N[$key]);
		    		
		    	}
		    }
		    	
    	}
    	
    	
    }
}
?>