<?php

class sendmail {
	
	var $to;
	var $subject;
	var $body;
	var $sender_email;
	var $sender_name;
	var $headers;
	
    function send($_to = "") {    	
    	$this->to = $_to!= "" ? $_to : $this->to;
    	
    	$this->process_header();
    	    	
    	/* Mail, optional paramiters. */
		$sendmail_params  = "-f".$this->sender_email;
			
    	mb_language("ja");
    	$result = mail($this->to, $this->subject, $this->body, $this->headers, $sendmail_params);
    	
    	return $result;    	
    }
    
    function set_to($_to){    	
    	$this->to = $_to;    	
    }
    
    function set_subject($_subject){    	
    	$this->subject = $_subject;    	
    	mb_language("ja");
    	$this->subject = mb_convert_encoding($this->subject, "ISO-2022-JP","AUTO");
    	$this->subject = mb_encode_mimeheader($this->subject);
    }
    
    function set_body($_body){
    	$this->body = mb_convert_encoding($this->han_kaku_to_jen_kaku($this->special_kanji($_body)), "ISO-2022-JP","AUTO");
    }
    
    function set_sender_mail($_sender){
    	$this->sender_email = $_sender;    	
    }
    
    function set_sender_name($_sender_name){
    	$this->sender_name = $_sender_name;
    }
    
    function process_header(){
    	
    	$this->headers  = "MIME-Version: 1.0 \n" ;
		$this->headers .= "From: ".mb_encode_mimeheader(mb_convert_encoding($this->sender_name,"ISO-2022-JP","AUTO")) ."<". $this->sender_email ."> \n";
		$this->headers .= "Reply-To: ".mb_encode_mimeheader(mb_convert_encoding($this->sender_name,"ISO-2022-JP","AUTO")) ."<". $this->sender_email ."> \n";	 
		
		$this->headers .= "Content-Type: text/plain;charset=ISO-2022-JP \n";
    }
    
    function han_kaku_to_jen_kaku($str){
		$replace_of = array('ｳﾞ','ｶﾞ','ｷﾞ','ｸﾞ',
							'ｹﾞ','ｺﾞ','ｻﾞ','ｼﾞ',
							'ｽﾞ','ｾﾞ','ｿﾞ','ﾀﾞ',
							'ﾁﾞ','ﾂﾞ','ﾃﾞ','ﾄﾞ',
							'ﾊﾞ','ﾋﾞ','ﾌﾞ','ﾍﾞ',
							'ﾎﾞ','ﾊﾟ','ﾋﾟ','ﾌﾟ','ﾍﾟ','ﾎﾟ');
		$replace_by = array('ヴ','ガ','ギ','グ',
							'ゲ','ゴ','ザ','ジ',
							'ズ','ゼ','ゾ','ダ',
							'ヂ','ヅ','デ','ド',
							'バ','ビ','ブ','ベ',
							'ボ','パ','ピ','プ','ペ','ポ');
		$_result = str_replace($replace_of, $replace_by, $str);
		
		$replace_of = array('ｱ','ｲ','ｳ','ｴ','ｵ',
							'ｶ','ｷ','ｸ','ｹ','ｺ',
							'ｻ','ｼ','ｽ','ｾ','ｿ',
							'ﾀ','ﾁ','ﾂ','ﾃ','ﾄ',
							'ﾅ','ﾆ','ﾇ','ﾈ','ﾉ',
							'ﾊ','ﾋ','ﾌ','ﾍ','ﾎ',
							'ﾏ','ﾐ','ﾑ','ﾒ','ﾓ',
							'ﾔ','ﾕ','ﾖ','ﾗ','ﾘ',
							'ﾙ','ﾚ','ﾛ','ﾜ','ｦ',
							'ﾝ','ｧ','ｨ','ｩ','ｪ',
							'ｫ','ヵ','ヶ','ｬ','ｭ',
							'ｮ','ｯ','､','｡','ｰ',
							'｢','｣','ﾞ','ﾟ');
		$replace_by = array('ア','イ','ウ','エ','オ',
							'カ','キ','ク','ケ','コ',
							'サ','シ','ス','セ','ソ',
							'タ','チ','ツ','テ','ト',
							'ナ','ニ','ヌ','ネ','ノ',
							'ハ','ヒ','フ','ヘ','ホ',
							'マ','ミ','ム','メ','モ',
							'ヤ','ユ','ヨ','ラ','リ',
							'ル','レ','ロ','ワ','ヲ',
							'ン','ァ','ィ','ゥ','ェ',
							'ォ','ヶ','ヶ','ャ','ュ',
							'ョ','ッ','、','。','ー',
							'「','」','”','');		
		$_result = str_replace($replace_of, $replace_by, $_result);
		return $_result;
	}
	
	function special_kanji($str){
		$replace_of = array('㈱','㈲','①','②','③','④','⑤','⑥','⑦','⑧','','');
		$replace_by = array('株式会社','有限会社','1.','２.','３．','４．','５．','６．','７．','８．','','');
		$_result = str_replace($replace_of, $replace_by, $str);
		return $_result;
	}
}
?>